package com.fs.aiSipCall.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.fs.aiSipCall.RemoteCommon;
import com.fs.aiSipCall.domain.AiSipCallGateway;
import com.fs.aiSipCall.mapper.AiSipCallGatewayMapper;
import com.fs.aiSipCall.service.IAiSipCallGatewayService;
import com.fs.aiSipCall.utils.SipLogUtil;
import com.fs.common.core.page.TableDataInfo;
import com.fs.common.utils.DateUtils;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * aiSIP外呼网关Service业务层处理
 * 
 * @author fs
 * @date 2026-03-06
 */
@Service
public class AiSipCallGatewayServiceImpl extends ServiceImpl<AiSipCallGatewayMapper, AiSipCallGateway> implements IAiSipCallGatewayService {

    private static final Logger log = SipLogUtil.createSipLogger(AiSipCallGatewayServiceImpl.class);

    /**
     * 查询aiSIP外呼网关
     * 
     * @param id aiSIP外呼网关主键
     * @return aiSIP外呼网关
     */
    @Override
    public AiSipCallGateway selectAiSipCallGatewayById(Long id)
    {
        return baseMapper.selectAiSipCallGatewayById(id);
    }


    @Override
    public TableDataInfo remoteList(AiSipCallGateway aiSipCallGateway) {
        //先使用远程网关
        String result = RemoteCommon.sendPost(RemoteCommon.REMOTE_ADDERSS_PREFIX + RemoteCommon.GATEWAY_LIST_API, JSONObject.toJSONString(aiSipCallGateway));
        if(StringUtils.isNotBlank(result)){
            JSONObject jsonObject = JSONObject.parseObject(result);
            if(jsonObject.getInteger("code") == 0){
                return JSONObject.parseObject(result, TableDataInfo.class);
            }else{
                log.error("获取网关接口失败:{}", jsonObject.getString("msg"));
            }
        }else{
            log.error("获取网关接口失败:无返回结果");
        }
        return null;
    }

    /**
     * 查询aiSIP外呼网关列表
     * 
     * @param aiSipCallGateway aiSIP外呼网关
     * @return aiSIP外呼网关
     */
    @Override
    public List<AiSipCallGateway> selectAiSipCallGatewayList(AiSipCallGateway aiSipCallGateway)
    {
        return baseMapper.selectAiSipCallGatewayList(aiSipCallGateway);
    }

    /**
     * 新增aiSIP外呼网关
     * 
     * @param aiSipCallGateway aiSIP外呼网关
     * @return 结果
     */
    @Override
    public int insertAiSipCallGateway(AiSipCallGateway aiSipCallGateway)
    {
        return baseMapper.insertAiSipCallGateway(aiSipCallGateway);
    }

    /**
     * 修改aiSIP外呼网关
     * 
     * @param aiSipCallGateway aiSIP外呼网关
     * @return 结果
     */
    @Override
    public int updateAiSipCallGateway(AiSipCallGateway aiSipCallGateway)
    {
        aiSipCallGateway.setUpdateTime(DateUtils.getNowDate());
        return baseMapper.updateAiSipCallGateway(aiSipCallGateway);
    }

    /**
     * 批量删除aiSIP外呼网关
     * 
     * @param ids 需要删除的aiSIP外呼网关主键
     * @return 结果
     */
    @Override
    public int deleteAiSipCallGatewayByIds(Long[] ids)
    {
        return baseMapper.deleteAiSipCallGatewayByIds(ids);
    }

    /**
     * 删除aiSIP外呼网关信息
     * 
     * @param id aiSIP外呼网关主键
     * @return 结果
     */
    @Override
    public int deleteAiSipCallGatewayById(Long id)
    {
        return baseMapper.deleteAiSipCallGatewayById(id);
    }

}
